class Locmare.FilerModule.Body extends Pettanr.View
  tagName: 'ul'
  className: 'filer-body'
  
  initialize: (options) ->
    @filer = options.filer
    @file_header = new (@module().FileHeader)({'body': this})
    @file_body = new (@module().FileBody)({'body': this})
    @listenTo(@file_body, 'click:pick', @click_pick)
    @listenTo(@file_body, 'click:symbol', @click_symbol)
    @listenTo(@file_body, 'http_get', @http_get)
    @listenTo(@file_body, 'http_post', @http_post)
    @listenTo(@file_body, 'remove', @remove)
  
  render: () ->
    this.$el.append(@file_header.render().el)
    this.$el.append(@file_body.render().el)
    @append_rb()
    this
  
  manifest: () ->
    @filer.manifest
  
  item_name: () ->
    @filer.item_name
  
  model: () ->
    @filer.model()
  
  items: () ->
    @filer.items
  
  add_pick: (target_model) ->
    @file_header.add_pick(target_model)
    @file_body.add_pick(target_model)
  
  click_pick: (file_item_view) ->
    @trigger('click:pick', file_item_view)
  
  click_symbol: (symbol_view) ->
    @trigger('click:symbol', symbol_view)
  
  http_get: (url) ->
    @trigger('http_get', url)
  
  http_post: (url) ->
    @trigger('http_post', url)
  
  remove: (item) ->
    @trigger('remove', item)
  
  module: () ->
    Locmare.FilerModule.BodyModule
  
class Locmare.FilerModule.BodyModule

