class Pettanr.File
  
  constructor: (@filename) ->
  
class Pettanr.ImageFile extends Pettanr.File
  
  src: () ->
    @filename
  
  width: () ->
    null
  
  height: () ->
    null
  
  real_size: () ->
    [@width(), @height()]
  
  has_size: () ->
    @width() and @height()
  
  tag_options: () ->
    {}
  
  thumbnail_size: () ->
    if @has_size()
      Pettanr.View.Image.to_thumbnail_size(@width(), @height())
    else
      Pettanr.View.Image.thumbnail_size()
  
  minicon_size: () ->
    if @has_size()
      Pettanr.View.Image.to_minicon_size(@width(), @height())
    else
      Pettanr.View.Image.minicon_size()
  
class Pettanr.PictureFile extends Pettanr.ImageFile
  
  constructor: (@item, subdir = null) ->
    @filename = @item.r_url(subdir)
  
  width: () ->
    Math.abs(@item.get('width'))
  
  height: () ->
    Math.abs(@item.get('height'))
  
  tag_options: () ->
    {}
  
