# image: picture item or image file
class Pettanr.View.Icon extends Tag.Img
  
  constructor: (@image, options) ->
    super(options)
  
  initialize: (options) ->
    options ||= @image.tag_options()
    attr = {}
    attr['src'] = @image.src()
    size = @get_size()
    attr['width'] = size[0] if size[0]
    attr['height'] = size[1] if size[1]
    alt = if _.isFunction(options.alt)
      options.alt()
    else
      options.alt
    attr['alt'] = alt || 'no title'
    title = if _.isFunction(options.title)
      options.title()
    else
      options.title
    attr['title'] = title || 'no title'
    opt = {
      attr: attr,
      class_name: options.class_name
    }
    super(opt)
  
  get_size: () ->
    @image.thumbnail_size()
  
class Pettanr.View.Minicon extends Pettanr.View.Icon
  
  get_size: () ->
    @image.minicon_size()
  
class Pettanr.View.RealIcon extends Pettanr.View.Icon
  
  get_size: () ->
    @image.real_size()
  
