class ResourcePicturesController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_action :authenticate_user, :only => [:new, :create, :update, :destroy]
    before_action :authenticate_artist, :only => [:new, :create, :update, :destroy]
  else
    before_action :authenticate_resource_reader, :only => [
      :index, :show, :credit, 
      :by_original_picture, :by_license_group, :by_license, :by_artist, :search
    ]
    before_action :authenticate_user, :only => [:new, :create, :update, :destroy]
    before_action :authenticate_artist, :only => [:new, :create, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def by_original_picture
    filer_list param: params[:id]
  end
  
  def by_license_group
    filer_list param: params[:id]
  end
  
  def by_license
    filer_list param: params[:id]
  end
  
  def by_artist
    filer_list param: params[:id]
  end
  
  def show_html_format format
    format.html {
      @item.boosts 'post'
    }
  end
  
  def show
    set_show
    respond_to do |format|
      opt = {:type => @item.mime_type, :disposition=>"inline"}
      format.png { send_data(@item.restore(params[:subdir]), opt ) }
      format.gif { send_data(@item.restore(params[:subdir]), opt ) }
      format.jpeg { send_data(@item.restore(params[:subdir]), opt ) }
      show_html_format format
      show_prof_format format
      show_json_format format
    end
  end
  
  def credit
    @resource_picture = ResourcePicture.show(params[:id], @operators)
    
    respond_to do |format|
      format.html { render :layout => false } # show.html.erb
    end
  end
  
  def new
    # use @item, @original_picture
    respond_to do |format|
      format.html
    end
  end
  
  def create
    @original_picture = OriginalPicture.edit params[:original_picture_id], @operators
    @imager = PettanImager.load @original_picture.restore
    jsn = nil
    if params[:json]
      jsn = JSON.parse_no_except(params[:json])
    end
    @item = @original_picture.resource_picture || ResourcePicture.new
    @prm = if params[:resource_picture] == nil or params[:resource_picture].empty?
      jsn
    else
      @item.permit_params(params)
    end
    @prm.delete 'id'
    @item.attributes = @prm
    @item.overwrite @original_picture
    @item.boosts 'post'
    
    respond_to do |format|
      if @item.store(@imager)
        format.html { redirect_to @item }
        format.json { render json: @item.to_json, status: :created, location: @item }
      else
        format.html { render action: "new" }
        format.json { render json: @item.errors, status: :unprocessable_entity }
      end
    end
  end
  
  def destroy
    set_model
    @item = @my_model_class.edit(params[:id], @operators)
    render_destroy_by 'unpublish', '/home/' + @item.path_name
  end
  
  def count
    @resource_picture = {:count => ResourcePicture.visible_count}
    respond_to do |format|
      format.json { render json: @resource_picture.to_json }
    end
  end
  
  def search
    @resource_pictures = ResourcePicture.find_by_md5(params[:md5])
    
    respond_to do |format|
      format.html
      format.json { render json: @resource_pictures.to_json }
    end
  end
  
end
