module LocalManifest
  module FilerModule
    module EditModule
      class Base < ManifestBase::TypeArgs
        
        def set_default
          super
        end
        
        def init
          super
        end
        
        def visible?
          @type != 'none'
        end
        
      end
      
      class Default < Base
      end
      
      class None < Base
      end
      
      class Account < Base
      end
      
      class Template < Base
        attr  :template_name
        
        def set_default
          super
          @args['template_name'] ||= 'edit'
        end
        
        def init
          super
          @template_name = @args['template_name']
        end
        
      end
      
    end
  end
end
