require_dependency "locmare/filer/header"
require_dependency "locmare/filer/body"
module Locmare
  class Filer
    include FilerModule
    
    attr :manifest, :item_name, :items, :page_status, :operators, :template_dir, 
      :header, :body
      
    def initialize item_name, items, page_status, operators
      @item_name = item_name
      @items = items
      @page_status = page_status
      @operators = operators
      @manifest = LocalManifest.manifest.filers[@item_name]
      @template_dir = 'templates/r/filer/'
      @header = Header.new self
      @body = self.mybody.new self
    end
    
    def model
      ::Manifest::item_name_to_model @item_name
    end
    
    # switch body class for dialog
    def mybody
      Body
    end
    
    def template_file_name
      "filer"
    end
    
    def template_name
      self.template_dir + self.template_file_name
    end
    
    def image_dir
      '/images/'
    end
    
  end
end

