module Locmare
  module FilerModule
    module BodyModule
      module FileBodyModule
        module FileItemModule
          module EditItemColumnModule
            class Base
              attr :file_item, :edit_manifest, :item, :column_name
              
              def initialize file_item, edit_manifest, item
                @file_item = file_item
                @edit_manifest = edit_manifest
                @item = item
                @column_name = 'edit'
              end
              
              def filer
                @file_item.filer
              end
              
              def manifest
                self.filer.manifest
              end
              
              def item_name
                self.filer.item_name
              end
              
              def image_dir
                self.filer.image_dir
              end
              
              def column_template_dir
                self.filer.template_dir + 'item_column/'
              end
              
              def column_template_file_name
                raise "undefined column_template_file_name\n"
              end
              
              def column_template_name
                self.column_template_dir + self.column_template_file_name
              end
              
              def item_template_dir
                self.filer.template_dir + 'edit/'
              end
              
              def item_template_file_name
                raise "undefined item_template_file_name\n"
              end
              
              def item_template_name
                self.item_template_dir + self.item_template_file_name
              end
              
            end
            
            class Default < Base
              def column_template_file_name
                'show'
              end
              
              def item_template_file_name
                if @item.own? self.filer.operators
                  'default'
                else
                  'none'
                end
              end
              
              def edit_img_file_name
                self.image_dir + 'edit.png'
              end
              
              def remove_img_file_name
                self.image_dir + 'remove.png'
              end
              
              def img_opt
                {:width => Manifest.manifest.magic_numbers['thumbnail_width'] / 2, 
                  :height => Manifest.manifest.magic_numbers['thumbnail_height'] / 2}
              end
              
              def edit_img_opt
                img_opt.merge :src => self.edit_img_file_name
              end
              
              def remove_img_opt
                img_opt.merge :src => self.remove_img_file_name
              end
              
            end
            
            class None < Base
              def column_template_file_name
                'none'
              end
              
            end
            
            class Account < Base
              def column_template_file_name
                'show'
              end
              
              def item_template_file_name
                if @item.own? self.filer.operators
                  'account'
                else
                  'none'
                end
              end
              
              def edit_img_file_name
                self.image_dir + 'edit.png'
              end
              
              def img_opt
                {:width => Manifest.manifest.magic_numbers['thumbnail_width'] / 2, 
                  :height => Manifest.manifest.magic_numbers['thumbnail_height'] / 2}
              end
              
              def edit_img_opt
                img_opt.merge :src => self.edit_img_file_name
              end
              
            end
            
            class Template < Base
              def column_template_file_name
                'show'
              end
              
              def item_template_file_name
                'template'
              end
              
              def template_dir
                @item.path_name + '/'
              end
              
              def template_file_name
                @edit_manifest.template_name
              end
              
              def template_name
                self.template_dir + self.template_file_name
              end
              
            end
            
          end
        end
      end
    end
  end
end
