module Locmare
  module FilerModule
    module BodyModule
      module FileBodyModule
        module FileItemModule
          module  SummaryItemColumnModule
            class Base
              attr :file_item, :summary_manifest, :item, :column_name
              
              def initialize file_item, summary_manifest, item
                @file_item = file_item
                @summary_manifest = summary_manifest
                @item = item
                @column_name = 'summary'
              end
              
              def filer
                @file_item.filer
              end
              
              def manifest
                self.filer.manifest
              end
              
              def item_name
                self.filer.item_name
              end
              
              def column_template_dir
                self.filer.template_dir + 'item_column/'
              end
              
              def column_template_file_name
                raise "undefined column_template_file_name\n"
              end
              
              def column_template_name
                self.column_template_dir + self.column_template_file_name
              end
              
              def item_template_dir
                self.filer.template_dir + 'summary/'
              end
              
              def item_template_file_name
                raise "undefined item_template_file_name\n"
              end
              
              def item_template_name
                self.item_template_dir + self.item_template_file_name
              end
              
            end
            
            class None < Base
              def column_template_file_name
                "none"
              end
              
            end
            
            class Template < Base
              def column_template_file_name
                'show'
              end
              
              def item_template_file_name
                'template'
              end
              
              def template_dir
                @item.path_name + '/'
              end
              
              def template_file_name
                @summary_manifest.template_name
              end
              
              def template_name
                self.template_dir + self.template_file_name
              end
              
            end
          end
        end
      end
    end
  end
end
