require_dependency "manifest/system_resource/template"
module Manifest
  class SystemResource
    include SystemResourceModule
    def self.set_default system_resource_manifest
      system_resource_manifest['templates'] ||= {}
      system_resource_manifest['select_items'] ||= {}
      #oh my ...
      #JSON.stringify couldn't print 1.0 
      # 1 == 1.0 ?
      #change class
      system_resource_manifest['select_items']['speech_font_size_items'] ||= {}
      system_resource_manifest['select_items']['speech_font_size_items'].each {|conf|
        conf[1] = conf[1].to_f 
      }
      system_resource_manifest
    end
    
    attr :templates, :select_items
    def initialize manifest, system_resource_manifest
      @manifest = manifest
      @system_resource_manifest = system_resource_manifest
      @templates = Template.manager(self, @system_resource_manifest['templates'])
      @select_items = system_resource_manifest['select_items']
    end
    
    # call after load app
    def init
      self.select_items_loader
    end
    
    def select_items_loader
      @manifest.models.each {|model_name, model_manifest|
        model_manifest.attributes.each {|attribute_name, attribute_manifest|
          source_manifest = attribute_manifest.source
          next unless source_manifest
          next unless source_manifest.type == 'model'
          resource_item_name = source_manifest.resource_item_name
          resource_action_name = source_manifest.resource_action_name
          caption = source_manifest.caption_name
          resource_controller_name = ::Manifest.manifest.pluralize(resource_item_name)
          my_controller = Manifest.manifest.controllers[resource_controller_name]
          my_action = my_controller.actions[resource_action_name]
          list = my_action.find page_size: -1
          @select_items[source_manifest.select_item_name] = 
            list.map {|item| [item.attributes[caption], item.id]}
        }
      }
    end
    
  end
end

